#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    conjure_object::private::DeriveWith
)]
#[serde(crate = "conjure_object::serde")]
#[derive_with(PartialEq, Eq, PartialOrd, Ord, Hash)]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct FftNode {
    #[builder(custom(type = super::NumericSeriesNode, convert = Box::new))]
    #[serde(rename = "input")]
    input: Box<super::NumericSeriesNode>,
    #[builder(default, into)]
    #[serde(rename = "window", skip_serializing_if = "Option::is_none", default)]
    window: Option<super::super::super::api::FftWindow>,
    #[builder(
        default,
        custom(
            type = impl
            Into<Option<super::super::super::api::FrequencySummarizationStrategy>>,
            convert = |v|v.into().map(Box::new)
        )
    )]
    #[serde(
        rename = "summarizationStrategy",
        skip_serializing_if = "Option::is_none",
        default
    )]
    summarization_strategy: Option<
        Box<super::super::super::api::FrequencySummarizationStrategy>,
    >,
    #[builder(default, into)]
    #[serde(rename = "nfft", skip_serializing_if = "Option::is_none", default)]
    nfft: Option<i32>,
}
impl FftNode {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(input: super::NumericSeriesNode) -> Self {
        Self::builder().input(input).build()
    }
    #[inline]
    pub fn input(&self) -> &super::NumericSeriesNode {
        &*self.input
    }
    #[inline]
    pub fn window(&self) -> Option<&super::super::super::api::FftWindow> {
        self.window.as_ref().map(|o| &*o)
    }
    #[inline]
    pub fn summarization_strategy(
        &self,
    ) -> Option<&super::super::super::api::FrequencySummarizationStrategy> {
        self.summarization_strategy.as_ref().map(|o| &**o)
    }
    #[inline]
    pub fn nfft(&self) -> Option<i32> {
        self.nfft.as_ref().map(|o| *o)
    }
}
